using System;
using System.Diagnostics;
using System.IO;
using System.Media;
using System.Reflection;
using System.Windows.Media;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace Plugins.ImStuck
{
    public class ImStuck : HBPlugin
    {
        private static readonly Stopwatch ImStuckTimer = new Stopwatch();
        private static readonly LocalPlayer Me = StyxWoW.Me;
        private readonly Version _version = new Version(1, 0);
        private WoWPoint _wpLast;
        public static readonly string BotPath = GetImStuckPath();
        public static readonly string SoundPath = Path.Combine(BotPath, "Sounds\\");

        public override string Name
        {
            get { return "I'm Stuck!"; }
        }

        public override string Author
        {
            get { return "Proto"; }
        }

        public override Version Version
        {
            get { return _version; }
        }
		
        public override bool WantButton 
		{ 
			get { return true; } 
		}
		
        public override string ButtonText 
		{ 
			get { return "None"; } 
		}
		
		public override void OnEnable()
        {
            _wpLast = Me.Location;
            ImStuckTimer.Reset();
            Logging.Write(Colors.Orange, "I'm Stuck! - Enabled v" + Version);
            base.OnEnable();
        }

        public override void OnDisable()
		{
            Logging.Write(Colors.OrangeRed, "I'm Stuck! - Disabled");
            base.OnDisable();
		}

        public override void Pulse()
        {
            if (Me.IsMoving)
            {
                if (!ImStuckTimer.IsRunning)
                    ImStuckTimer.Start();
                else if (ImStuckTimer.Elapsed.TotalSeconds > 10.0)
                {
                    if (Me.Location.Distance(_wpLast) < 6) 
                    {
                        var rand = new Random((int) DateTime.Now.Ticks);
                        var next = rand.Next(-2, 2);
                        if (next > 0 && next <= 1 || next < 0 && next >= -1 || next < -1 || next == 0)
                        {
                            //Logging.Write(Colors.OrangeRed, "[I'm Stuck!]: I'm moving but not going anywhere!");
							Alarm.SoundLocation = SoundPath + "beep.wav";
							Alarm.Play();
                        }
                    }
                    else
                    {
                        ImStuckTimer.Reset();
                        _wpLast = Me.Location;
                    }
                }
            }
            else
            {
                if (ImStuckTimer.IsRunning)
                {
                    ImStuckTimer.Stop();
                    ImStuckTimer.Reset();
                }
            }
        }

        public static readonly SoundPlayer Alarm = new SoundPlayer();

        private static string GetImStuckPath()
        { 
            var asmName = Assembly.GetExecutingAssembly().GetName().Name;
            var len = asmName.LastIndexOf("_", StringComparison.Ordinal);
            var folderName = asmName.Substring(0, len);

            var pluginsPath = GlobalSettings.Instance.PluginsPath;
            if (!Path.IsPathRooted(pluginsPath))
            {
                pluginsPath = Path.Combine(Utilities.AssemblyDirectory, pluginsPath);
            }
            return Path.Combine(pluginsPath, folderName);
        }
    }
}
